Begin Transaction;

Create Table [VersionInfo]
{
    [Version] TEXT NOT NULL
};

Create Table [FinanceItem]
(
    [Key] INTEGER PRIMARY KEY NOT NULL,
    [Name] TEXT NOT NULL,
    [Type] INT NOT NULL DEFAULT 0,
    [Parent] INTEGER NOT NULL DEFAULT 0,
    [Shutcut] TEXT
);


Create Table [FinanceRecord]
(
    [Key] BIGINT PRIMARY KEY NOT NULL,
    [Comment] TEXT,
    [Amount] FLOAT NOT NULL DEFAULT 0,
    [Type] INTEGER NOT NULL,
    [CreatedTime] TIMESTAMP NOT NULL,
    [LastRenewTime] TIMESTAMP NOT NULL
);

Create Index IDX_FR_TYPE on [FinanceRecord](Type);
Create Index IDX_FR_CTIME on [FinanceRecord](CreatedTime);
Create Index IDX_FR_RTIME on [FinanceRecord](LastRenewTime);

insert into [VersionInfo] (Version) values ('1.0.1.0');

insert into [FinanceItem] (Key,Name,Type,Shutcut) values (1,'工资',0,'G');
insert into [FinanceItem] (Key,Name,Type,Shutcut) values (2,'奖金',0,'J');
insert into [FinanceItem] (Key,Name,Type,Shutcut) values (3,'分红',0,'F');
insert into [FinanceItem] (Key,Name,Type,Shutcut) values (5,'礼金',0,'L');
insert into [FinanceItem] (Key,Name,Type,Shutcut) values (6,'其他收入',0,'Q');

insert into [FinanceItem] (Key,Name,Type,Shutcut) values (7,'日常开支',1,'R');
insert into [FinanceItem] (Key,Name,Type,Shutcut) values (8,'交通',1,'T');
insert into [FinanceItem] (Key,Name,Type,Shutcut) values (9,'饮食',1,'Y');  
insert into [FinanceItem] (Key,Name,Type,Shutcut) values (10,'通讯',1,'X');
insert into [FinanceItem] (Key,Name,Type,Shutcut) values (11,'娱乐',1,'Z');
insert into [FinanceItem] (Key,Name,Type,Shutcut) values (12,'孝敬父母',1,'M');
insert into [FinanceItem] (Key,Name,Type,Shutcut) values (13,'卫生医疗费',1,'W');
insert into [FinanceItem] (Key,Name,Type,Shutcut) values (14,'其他开支',1,'C');

Commit Transaction;